(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Scale = (function () {
        function Scale(payload, config) {
            this.symbols = ['', 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y'];
            this.step = 1000;
            this.num = 0;
            this.symbol = '';
            var _a = this.convert(payload), symbol = _a.symbol, num = _a.num;
            this.raw = payload;
            this.symbol = symbol;
            this.num = num;
            if (config) {
                this.symbols = config.symbols;
                this.step = config.step;
            }
        }
        Scale.prototype.convert = function (payload) {
            var num = typeof payload === 'string' ? Number(payload) : payload;
            var idx = 0;
            while (idx < this.symbols.length - 1 && Math.abs(num) >= this.step) {
                num = Math.round(num / this.step);
                idx += 1;
            }
            return {
                num: num,
                symbol: this.symbols[idx]
            };
        };
        Scale.prototype.invalid = function () {
            return isNaN(Number(this.raw));
        };
        Scale.prototype.valid = function () {
            return !this.invalid();
        };
        Scale.prototype.output = function () {
            return this.valid() ? "" + this.num + this.symbol : undefined;
        };
        return Scale;
    }());
    exports.Scale = Scale;
});
